import pickle

default_histogramFilename = '.user-model.histogram'

class userModel:
    def __init__(self, filename=default_histogramFilename):
        file = open(filename, 'r')
        self._histogram = pickle.load(file)
        file.close()

    def incorporate(self, string, wordTree, separated=None):
        for start, end in wordTree.find_matches(string,separated=separated):
            self.add_word(string[start:end])

    def add_word(self, string):
        self._histogram.add(string)

    def valueOf(self, string):
        self._histogram.percentToMax(string)

    def wordsMoreThan(self, value = 50):
        words = []
        for word in self._histogram.words():
            if self._histogram.percentToMax(word) >= value:
                words.append(word)
        return words

    def wordsLessThan(self, value = 50):
        words = []
        for word in self._histogram.words():
            if self._histogram.percentToMax(word) < value:
                words.append(word)
        return words
            
    def save(self, filename=default_histogramFilename):
        file = open(filename, 'w')
        pickle.dump(self._histogram, file)
        file.close()
