import string
import urllib
import glossary

__all__ = ["lomAutolinker"]

class lomAutoLinker:
    def __init__(self, url):
        print 'New Linker'
        self.url = url
        self.dictionary = None
        self.wordTree = None
        self.readConcepts()
        
    def readConcepts(self):
        print 'Reading Concepts'
        allConceptsString = urllib.urlopen(self.url+'allConceptsMap').read()
        dict = parseConcepts(allConceptsString)
        tree = glossary.htmlWordTree()
        for key in dict.keys():
            tree.add(key)
        self.dictionary = dict
        self.wordTree = tree
        print '...Done'
        
    def autoLink(self, string, color='#ffe000', words=None, separated=None):
        if words:
            t = self.wordTree
            tree = glossary.htmlWordTree()
            for w in words:
                if t.match(w):
                    tree.add(w)
        else:
            print 'Using all concepts'
            tree = self.wordTree
        dict = self.dictionary
        outString = ''
        while tree is None or dict is None:
            self.readConcepts()
            tree = self.wordTree
            dict = self.dictionary
        index = 0
        for start,end in tree.find_matches(string.lower(),separated=separated):
            concept = string[start:end]
            new = '%s<a style="color:black;background-color:%s;text-decoration:none" target="concepts" href="%s%s">%s</a>'%(string[index:start],color,self.url,dict[concept.lower()],concept)
            outString = outString + new
            index = end
        outString = outString + string[index:]
        return outString

conceptName="'sortkey': '"
conceptNameLen = len(conceptName)
conceptId="'id': '"
conceptIdLen = len(conceptId)

def parseConcepts(string):
    concepts = {}.copy()
    index = 0
    end = len(string)
    while index < end:
        while string[index:index+conceptNameLen] != conceptName:
            index = index + 1
            if index >= end:
                return concepts
        index = index + conceptNameLen
        next = index
        while string[next] != "'":
            next = next + 1
            if next >= end:
                return concepts
        name = string[index:next]
        index = next + 1
        while string[index:index+conceptIdLen] != conceptId:
            index = index + 1
            if index >= end:
                return concepts
        index = index + conceptIdLen
        next = index
        while string[next] != "'":
            next = next + 1
            if next >= end:
                return concepts
        id = string[index:next]
        index = next + 1
        concepts[name.lower()]=id

if __name__ == '__main__':
    print readConcepts('http://localhost:9080/entwine/Concepts/')
